defmodule Reactivity.Application do

  use Application

  def start(_type, _args) do
    import Supervisor.Spec, warn: false

    # Define workers and child supervisors to be supervised
    children = [
      # Starts a worker by calling: Network.Worker.start_link(arg1, arg2, arg3)
      supervisor(Reactivity.Registry, [[]])
    ]
    # See http://elixir-lang.org/docs/stable/elixir/Supervisor.html
    # for other strategies and supported options
    opts = [strategy: :one_for_one, name: Reactivity.Application]
    Supervisor.start_link(children, opts)
  end
end
